/* 
 * File:   QueueNode.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a QueueNode, a place to store a TreeNode through a Queue.
 * It also contains a pointer to the following ListNode.
 * 
 * Based on Node, which was created on January 11, 2013, 3:31 PM
 */

#ifndef QUEUENODE_H
#define	QUEUENODE_H

#include <stdio.h>
#include "TreeNode.h"

class QueueNode {
public:
    //big three
    QueueNode();//default constructor
    QueueNode(const QueueNode& orig);//copy constructor (not defined)
    virtual ~QueueNode();//virtual destructor (not defined)
    
    //public utilities
    //getters and setters
    TreeNode* getLeaf();
    void setLeaf(TreeNode* leaf);
    QueueNode* getNext();
    void setNext(QueueNode* next);
private:
    TreeNode* _leaf;//TreeNode/leaf node contains
    QueueNode* _next;//pointer to next QueueNode
};

#endif	/* QUEUENODE_H */
