/* 
 * File:   Stack.cpp
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Implementation for Stack (see header file for description)
 * 
 * Based on earlier Stack, which was created January 31, 2013, 9:46 AM
 */

#include "Stack.h"

//**BIG THREE**
//constructor
Stack::Stack() {
    _first = NULL;
    _last = NULL;
}

//copy constructor (not defined)
Stack::Stack(const Stack& orig) {
}

//virtual destructor (not defined)
Stack::~Stack() {
}

//**PUBLIC UTILITIES**
//test if empty
bool Stack::isEmpty(){
    if (_first == NULL)
    {
        return true;
    }
    else
    {
        return false;
    }
}

//add a new string to the stack (through a StackNode)
void Stack::push(std::string newText) {
    //make the new node
    StackNode* newNode = new StackNode(newText);
    //its previous is what was the last node
    //if this is the first node, it's null, and this still works
    newNode->setPrevious(_last);
    
    //since we have a "last", we don't have to iterate to the end of the stack
    
    //is this the first node?
    if (_first == NULL)
    {
        //ok, make the new node be the first node
        _first = newNode;    
    }
    else
    {
        //set the next of what was the last node to the new one
        _last->setNext(newNode);
    }
    
    //now make the new node be the last node
    _last = newNode;
}

//slip the bottom StackNode out from under the stack, returning it
std::string Stack::slip(){
    //store the string of the node to be deleted
    std::string returnString = "";    
    //get a pointer to the first node (the node to be deleted!)
    StackNode* markedNode = _first;
    
    //only try to delete if there actually are nodes
    if (_first!=NULL)
    {
        //if there's only one node
        if (_first == _last)
        {
            //take away the "first" pointer to it...
            _first = NULL;        
        }
        else
        {
            //more than one node
            //set the 2nd node's "last" pointer to null
            markedNode->getNext()->setPrevious(NULL);
        }
        
        //change first pointer to point to what was the 2nd node
        //if there's only one node, this will be null, which is also good
        _first = markedNode->getNext();
        
        returnString = markedNode->getText();
        
        //kaboom
        delete markedNode;
    }
    
    return returnString;
}

//blast the top StackNode off the stack, returning it
std::string Stack::pop() {
    //store the string of the node to be deleted
    std::string returnString = "";    
    //get a pointer to the last node (the node to be deleted!)
    StackNode* markedNode = _last;
    
    //only try to delete if there actually are nodes
    if (_last!=NULL)
    {
        //if there's only one node
        if (_first == _last)
        {
            //take away the "first" pointer to it...
            _first = NULL;        
        }
        else
        {
            //more than one node
            //set the 2nd last node's "next" pointer to null
            markedNode->getPrevious()->setNext(NULL);
        }
        
        //change last pointer to point to what was the 2nd last node
        //if there's only one node, this will be null, which is also good
        _last = markedNode->getPrevious();
        
        returnString = markedNode->getText();
        
        //kaboom
        delete markedNode;
    }
    
    return returnString;
}
