/* 
 * File:   Stack.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a Stack. It is the means to manage StackNodes that store
 * standard strings (when they need to be stored in a pile).
 *
 * Based on earlier Stack, which was created January 31, 2013, 9:46 AM
 */

#ifndef STACK_H
#define	STACK_H

#include <iostream>
#include "StackNode.h"

//a stack to store standard strings when they need to be piled up
class Stack {
public:
    //big three
    Stack();//constructor
    Stack(const Stack& orig);//copy constructor (not defined)
    virtual ~Stack();//virtual destructor (not defined)
    
    //public utilities
    //test if empty
    bool isEmpty();
    //add a new string to the stack (through a StackNode)
    void push(std::string newText);
    //slip the bottom StackNode out from under the stack, returning it
    std::string slip();
    //blast the top StackNode off the stack, returning it
    std::string pop();
private:
    StackNode* _first;//pointer to first node
    StackNode* _last;//pointer to last node
};

#endif	/* STACK_H */
